<?php
/** ----------------------------------------------------------------------------
 **
 *F image_processing.php
 **
 ** WEB-Shop Software http://www.webs.de
 **
 ** ----------------------------------------------------------------------------
 ** based on:
 **  (c) 2002 osCommerce
 **  (c) 2003 nextcommerce; www.nextcommerce.org
 **  (c) 2006 XT-Commerce
 **
 ** Released under the GNU General Public License
 **
 ** @version $Id$
 ** @copyright 2011 WEB-Shop Software http://www.webs.de/
 **
 ** ------------------------------------------------------------------------- */

defined( '_VALID_XTC' ) or die( 'Direct Access to this location is not allowed.' );

define('MODULE_IMAGE_PROCESS_TEXT_DESCRIPTION', 'WEB-Shop Imageprocessing - Stapelverarbeitung f&uuml;r Bildbearbeitung');
define('MODULE_IMAGE_PROCESS_TEXT_TITLE', 'WEBS-Imageprocessing');
define('MODULE_IMAGE_PROCESS_STATUS_DESC','Modulstatus');
define('MODULE_IMAGE_PROCESS_STATUS_TITLE','Status');
define('IMAGE_EXPORT','Dr&uuml;cken Sie Ok um die Stapelverarbeitung zu starten, dieser Vorgang kann einige Zeit dauern, auf keinen Fall unterbrechen!.');
define('IMAGE_EXPORT_TYPE','<hr /><b>Stapelverarbeitung:</b>');
define('MODULE_IMAGE_PROCESS_TIME_LIMIT_TITLE','Zeitlimit');
define('MODULE_IMAGE_PROCESS_TIME_LIMIT_DESC','Der Fortschrittsbalken zeigt den Fortschritt der Bildergenerierung an. Wenn das angegebene Zeitlimit erreicht ist, wird der Prozess unterbrochen. Sie knnen dann auf einen Button Fortsetzen klicken. Falls Ihnen dieser Button nicht zugnglich ist, mssen Sie den Prozess mit einem kleineren Zeitlimit erneut starten.');
define('MODULE_IMAGE_PROCESS_AUTO_CONTINUE_TITLE','Automatisch Fortsetzen');
define('MODULE_IMAGE_PROCESS_AUTO_CONTINUE_DESC','Automatisches triggern des "Fortschritt" Buttons ber Javascript.');
define('MODULE_IMAGE_PROCESS_PROGRESS', 'Fortschritt');

define('MODULE_IMAGE_PROCESS_OUTPUT_BUFFERING_ENABLED', 'Achtung - output_buffering ist aktiviert - damit das Script funktioniert sollte diese deaktiviert werden. Fge folgende Zeile in die .htaccess ein. Bei Problemen konatktiere Deinen Provider:<br><pre>php_values output_buffering off</pre>');

class image_processing {
  var $code, $title, $description, $enabled;

  function image_processing() {
    global $order;

    $this->code = 'image_processing';
    $this->title = MODULE_IMAGE_PROCESS_TEXT_TITLE;
    $this->description = MODULE_IMAGE_PROCESS_TEXT_DESCRIPTION;
    $this->sort_order = MODULE_IMAGE_PROCESS_SORT_ORDER;
    $this->enabled = ((MODULE_IMAGE_PROCESS_STATUS == 'True') ? true : false);

    $this->timelimit = intval((isset($_POST['configuration']['MODULE_IMAGE_PROCESS_TIME_LIMIT']) ? $_POST['configuration']['MODULE_IMAGE_PROCESS_TIME_LIMIT'] : MODULE_IMAGE_PROCESS_TIME_LIMIT));
    $this->autoContinue = (isset($_POST['configuration']['MODULE_IMAGE_PROCESS_AUTO_CONTINUE']) ? $_POST['configuration']['MODULE_IMAGE_PROCESS_AUTO_CONTINUE'] : MODULE_IMAGE_PROCESS_AUTO_CONTINUE);
  }

  function process($file) {

    if (!isset($_SESSION['image_processing_done'])) {

      // include needed functions
      include ('includes/classes/'.FILENAME_IMAGEMANIPULATOR);  

      // action
      // get images in original_images folder
      $files=array();

      $starttime = time();

      if ($dir= opendir(DIR_FS_CATALOG_ORIGINAL_IMAGES)){
        while  ($file = readdir($dir)) {
          if (is_file(DIR_FS_CATALOG_ORIGINAL_IMAGES.$file) and ($file !="index.html") and (strtolower($file) != "thumbs.db")){
            $files[]=$file;
          }
        }
        closedir($dir);
      }
      sort($files);

      // check for files always processed;
      $i=0;
      if (isset($_SESSION['image_processing_last'])) {
        while($files[$i] <= $_SESSION['image_processing_last']) {
          $i++;
        }
      }

      echo '<h1>WEB-Shop Image Processing</h1>';
      echo '<div class="progress_box" style="width: 350px; margin: 10px; text-align: center;">';
      echo '<b>'.MODULE_IMAGE_PROCESS_PROGRESS.'</b>';
      print '<div style="left: 10px; right: 10px; width: 300px; height: 20px; border: inset #CCCCCC 3px; background-color: white;">';
      print '<div id="progressbar" class="person_box" style="width: '.intval($i*100/count($files)).'%; height: 18px; text-align: center; overflow: hidden; background-color: blue; color: yellow;">'.intval($i*100/count($files)).'%</div>';
      print '</div>';
      print '</div>';

      if ($this->timelimit != 0) {
        echo '<div class="progress_box" style="width: 350px; margin: 10px; text-align: center;">';
        echo '<b>'.MODULE_IMAGE_PROCESS_TIME_LIMIT_TITLE.':</b> '.$this->timelimit.'&nbsp;sec.';
        print '<div style="left: 10px; right: 10px; width: 300px; height: 20px; border: inset #CCCCCC 3px; background-color: white;">';
        print '<div id="timebar" class="person_box" style="width: 0%; height: 18px; text-align: center; overflow: hidden; background-color: blue; color: yellow;">0%</div>';
        print '</div>';
        print '</div>';
      }

?>
<script type="text/javascript">/* <![CDATA[ */
  function update_progress(images, time) {
    perc = Math.round(100*(images / <?php echo count($files) ?>));
		if (perc>100) perc = 100;
		progress = document.getElementById("progressbar");
		if (progress) {
			progress.style.width = perc+"%";
			progress.innerHTML = perc+"%";
		}
<?php if ($this->timelimit != 0) : ?>
		perc = Math.round(100*(time / <?php echo $this->timelimit ?>));
		if (perc>100) perc = 100;
		progress = document.getElementById("timebar");
		if (progress) {
			progress.style.width = perc+"%"; progress.innerHTML = perc+"%";
		}
<?php endif; ?>
	}
/* ]]> */</script>
<?php
      flush();
      $lastduration = 0;

      for ($n=sizeof($files);$i<$n;$i++) {

        // we allow a time limit of 3 seconds for each image
        @xtc_set_time_limit(3);

        // update the progressbar
        if (isset($exectime) and $exectime != $lastduration) {
          echo '<script type="text/javascript">/* <![CDATA[ */ update_progress('.($i).', '.$exectime.'); /* ]]> */</script>';
          flush();
          $lastduration = $exectime;
        }

        if ($files[$i] != 'Thumbs.db' &&  $files[$i] != 'Index.html') {
          $products_image_name = $files[$i];
          require(DIR_WS_INCLUDES . 'product_thumbnail_images.php');
          require(DIR_WS_INCLUDES . 'product_info_images.php');
          require(DIR_WS_INCLUDES . 'product_popup_images.php');
          $_SESSION['image_processing_last'] = $products_image_name;
        }

        $now = time();
        $exectime = $now - $starttime;

        // check for timelimit
        if ($this->timelimit != 0 and $this->timelimit - $exectime < 3) {
          break;
        }

      }
      echo '<script type="text/javascript">/* <![CDATA[ */ update_progress('.($i).', '.$this->timelimit.'); /* ]]> */</script>';
      flush();
      if ($i >= $n) {
        if (isset($_SESSION['image_processing_last'])) {
          unset($_SESSION['image_processing_last']);
        }
        $_SESSION['image_processing_done']=true;
      }
      print '<form name="continue" method="post"><input type="submit" name="continue" value="Fortsetzen" /></form>';

      if ($this->autoContinue=='True') {
?>
        <script type="text/javascript">/* <![CDATA[ */
          (function (fn) {
            if (window.addEventListener) window.addEventListener('load', fn, false);
            else window.attachEvent('onload', fn);
          })
          (function() {
            document.forms['continue'].elements['continue'].click();
          });
        /* ]]> */</script>
<?php
      }
      exit;

    } else {
      unset($_SESSION['image_processing_done']);
      $GLOBALS['messageStack']->add_session('WEB-Shop Imageprocessing abgeschlossen', 'success');
      xtc_redirect(xtc_href_link(FILENAME_MODULE_EXPORT, 'module=image_processing'));
    }


  }

  function display() {
    $text = IMAGE_EXPORT_TYPE.'<br />'.
      IMAGE_EXPORT.'<br /><br />';
    if (intval(ini_get('output_buffering')) != 0) {
      $text .= '<div style="background-color: red">'.MODULE_IMAGE_PROCESS_OUTPUT_BUFFERING_ENABLED.'</div><br />';
      $text .= xtc_button(BUTTON_REVIEW_APPROVE) . '&nbsp;';
    } else {
      $text .= xtc_button(BUTTON_REVIEW_APPROVE) . '&nbsp;';
    }
    $text .= xtc_button_link(BUTTON_CANCEL, xtc_href_link(FILENAME_MODULE_EXPORT, 'set=' . $_GET['set'] . '&module=image_processing'));
    return array('text'=>$text);
  }

  function check() {
    if (!isset($this->_check)) {
      $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_IMAGE_PROCESS_%'");
      $cnt = xtc_db_num_rows($check_query);
      if ($cnt > 0 and $cnt != count($this->keys())) {
        $this->remove();
        $this->install();

        $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key like 'MODULE_IMAGE_PROCESS_%'");
        $cnt = xtc_db_num_rows($check_query);
      }
      $this->_check = ($cnt == 3);
    }
    return $this->_check;
  }

  function install() {
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_IMAGE_PROCESS_STATUS', 'True',  '6', '1', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_IMAGE_PROCESS_TIME_LIMIT', '60',  '6', '2', now())");
    xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_IMAGE_PROCESS_AUTO_CONTINUE', 'True',  '6', '3', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
  }

  function remove() {
    xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
  }

  function keys() {
    return array('MODULE_IMAGE_PROCESS_STATUS', 'MODULE_IMAGE_PROCESS_TIME_LIMIT', 'MODULE_IMAGE_PROCESS_AUTO_CONTINUE');
  }

}
